Attribute VB_Name = "OpenFileDialog"
Option Explicit
'//    Windows API   Open File
'//       Excel

#If Win64 Then
    #If VBA7 Then    ' Windows x64, Office 2010
        Private Declare PtrSafe Function GetOpenFileName Lib "comdlg32.dll" Alias _
                                "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As LongLong
    #Else    ' Windows x64,Office 2003-2007
        Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias _
                                "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As LongLong
    #End If
#Else
    #If VBA7 Then    ' Windows x86, Office 2010
        Private Declare PtrSafe Function GetOpenFileName Lib "comdlg32.dll" Alias _
                                "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
    #Else    ' Windows x86, Office 2003-2007
        Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias _
                                "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
    #End If
#End If

Private Type OPENFILENAME
  lStructSize As Long
  hwndOwner As Long
  hInstance As Long
  lpstrFilter As String
  lpstrCustomFilter As String
  nMaxCustFilter As Long
  nFilterIndex As Long
  lpstrFile As String
  nMaxFile As Long
  lpstrFileTitle As String
  nMaxFileTitle As Long
  lpstrInitialDir As String
  lpstrTitle As String
  flags As Long
  nFileOffset As Integer
  nFileExtension As Integer
  lpstrDefExt As String
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As String
End Type

Public Function FindExcelFile(ByRef filePath As String) As Boolean
'    Excel.
' :
    ' FindExcelFile=False -     filePath
    ' FindExcelFile=True -   Cancel   
    
    Dim OpenFile As OPENFILENAME
    Dim lReturn As Long
    
    On Error Resume Next
    OpenFile.lStructSize = Len(OpenFile)    ' 
    '// Sample filter:
    '// "Text Files (*.txt)" & Chr$(0) & "*.sky" & Chr$(0) & "All Files (*.*)" & Chr$(0) & "*.*"
    OpenFile.lpstrFilter = "Excel Files (*.xls, *.xlsx)" & Chr(0) & "*.xls; *.xlsx"
    OpenFile.nFilterIndex = 1
    OpenFile.lpstrFile = String(512, 0) '  
    OpenFile.nMaxFile = Len(OpenFile.lpstrFile) - 1 ' 
    OpenFile.lpstrFileTitle = OpenFile.lpstrFile
    OpenFile.nMaxFileTitle = OpenFile.nMaxFile
    OpenFile.lpstrInitialDir = ThisDocument.Path    ' 
    OpenFile.lpstrTitle = "  "   ' 
    OpenFile.flags = 0  '   
    '    
    FindExcelFile = True
    filePath = vbNullString
    Err.Clear   '    
    ' 
    lReturn = GetOpenFileName(OpenFile)
    '      Cancel
    If Err.Number <> 0 Or lReturn = 0 Then Exit Function
    ' 
    FindExcelFile = False   'Cancel  
    filePath = Replace(Trim(OpenFile.lpstrFile), Chr(0), vbNullString) '  
End Function
